require 'nokogiri'
require 'open-uri'
require 'tjcrawler/crawler/result'
require 'tjcrawler/page'

module Tjcrawler
  class Crawler
    def initialize css_selector_for_link_tags
      @css = css_selector_for_link_tags
    end

    def crawl url
      uri = URI(url).tap(&:normalize!)
      content = open(uri).read
      doc = Nokogiri::HTML(content)
      links = doc.css(@css)
      Result.new url: uri.to_s, content: content, links: links.map{|link| uri.merge(link[:href]).to_s}
    end

    def start
      loop do
        sleep 1 until page = Page.dequeue
        print :'.'
        result = crawl page.url
        page.update(content: result.content)
        page.touch(:crawled_at)
        result.links.each{ |url| Page.enqueue url }
      end
    end
  end
end