require 'nokogiri'
require 'tjcrawler/page'
module Tjcrawler
  class Parser
    @@semaphore = Mutex.new
    # a nokogiri doc will be yield in block
    def initialize &block
      yield 'Block required' unless block_given?
      @strategy = block
    end

    def parse content
      doc = Nokogiri::HTML(content)
      ret = nil
      @@semaphore.synchronize{ ret = @strategy[doc] }
      print :'.'
      ret
    end

    def start
      loop do
        sleep 1 until page = find_next
        parse(page.content)
        page.touch(:parsed_at)
      end
    end

    private

    def find_next
      Page.where('crawled_at IS NOT NULL AND (parsed_at IS NULL OR parsed_at < ?)', 1.day.ago).order('parsed_at IS NOT NULL, parsed_at').first
    end
  end
end